@building-option +create-set-co
@create DAEMON-HANDLER named binary-mode http handler:binary-mode http handler
@prop _."partial_line" "" ""
@prop _."buffer" {} ""
@prop _."buffer_partial" "" ""
;_.("aliases") = {"binary-mode http handler"}

@verb _:"read" this none this
@program _:read
if (caller != this)
  raise(E_PERM);
endif
x = this.partial_line;
while (1)
  if (x)
    if (i = index(x, "~0D~0A"))
      skip = 6;
      break;
    elseif (i = index(x, "~0A"))
      skip = 3;
      break;
    endif
  endif
  try
    more = read(this);
    x = x + more;
  except (ANY)
    this:abort();
    kill_task(task_id());
  endtry
endwhile
line = x[1..i - 1];
x = x[i + skip..$];
this.partial_line = x;
return line;
.

@verb _:"notify notify_safe" this none this rxd #199
@program _:notify
{line} = args;
if (this.buffered)
  this:add_buffer(line);
else
  notify(this, encode_binary(line) + "~0D~0A");
endif
.

@verb _:"read_bytes" this none this rxd #199
@program _:read_bytes
"read up to N bytes";
if (caller == this)
  {bytes} = args;
  decoded = decode_binary(this.partial_line, 1);
  result = {};
  resid = bytes;
  while (resid > 0)
    if (length(decoded) >= resid)
      result = {@result, @decoded[1..resid]};
      decoded = decoded[resid + 1..$];
      resid = 0;
    else
      result = {@result, @decoded};
      resid = resid - length(decoded);
      try
        more = read(this);
        decoded = decode_binary(more, 1);
      except (ANY)
        this:abort();
        kill_task(task_id());
      endtry
    endif
  endwhile
  this.partial_line = encode_binary(decoded);
  blob = encode_binary(result);
  data = decode_binary(blob);
  lines = {};
  line = "";
  for entry in (data)
    if (entry == 13)
      lines = {@lines, line};
      line = "";
    elseif (typeof(entry) == STR)
      line = line + entry;
    endif
  endfor
  if (line)
    lines = {@lines, line};
  endif
  return {bytes, lines};
else
  return E_PERM;
endif
.

@verb _:"notify_lines" this none this rxd #199
@program _:notify_lines
{lines} = args;
if (this.buffered)
  return this:add_buffer_lines(lines);
else
  crlfd = {};
  for line in (lines)
    crlfd = {@crlfd, encode_binary(line) + "~0D~0A"};
  endfor
  return pass(crlfd);
endif
.

@verb _:"add_buffer_lines" this none this rxd
@program _:"add_buffer_lines"
{lines} = args;
if (caller == this && length(lines))
  {first, @rest} = lines;
  this:add_buffer(first);
  this.buffer = {@this.buffer, @rest};
  return 1;
endif
.

@verb _:"add_buffer" this none this
@program _:"add_buffer"
{line} = args;
if (caller == this)
  if (this.buffer_partial)
    this.buffer = {@this.buffer, this:partial_buffer_reset() + line};
  else
    this.buffer = {@this.buffer, line};
  endif
  return 1;
endif
.

@verb _:"partial_buffer_reset" this none this
@program _:"partial_buffer_reset"
if (caller == this)
  r = this.buffer_partial;
  this.buffer_partial = "";
  return r;
endif
.

@verb _:"notify_lines_safe" this none this rxd #199
@program _:notify_lines_safe
{lines} = args;
if (this.buffered)
  return this:add_buffer_lines(lines);
else
  for line in (lines)
    if ((ticks_left() < 4000) || (seconds_left() < 2))
      suspend(1);
    endif
    crlfd = encode_binary(line) + "~0D~0A";
    while (!notify(this, crlfd, 1))
      suspend(1);
    endwhile
  endfor
endif
"Copied from binary http thing (#4460):notify_lines by Xplat (#4014) Fri Jun  1 04:36:56 2001 PDT";
.

@verb _:"notify_raw" this none this rxd #199
@program _:notify_raw
if (caller != this)
  raise(E_PERM);
endif
return notify(this, @args);
.

"***finished***
