@building-option +create-set-co
@create $feature named MOO-XMPP (Jabber) feature:MOO-XMPP (Jabber) feature,XMPP,MOO-XMPP,Jabber,XMPP feature,Jabber feature
@prop _."options" #6864 rc
@prop _."users" {} ""
@prop _."buddy_lists" "waif" ""
;_.buddy_lists = $dict:new()
@prop _."tell_prefix" "[Jabber] " rc
@prop _."last_messaged" "waif" ""
;_.last_messaged = $dict:new()
;_.("feature_verbs") = {"@jabber-options", "@jabber-roster", "@jabber-add-buddy", "@jabber-remove-buddy", "@jabber-message", "@jabber-authorize", "@jabber-alias", "@jabber-gag"}
;_.("feature_ok") = 1
;_.("commands") = {"@jabber-o*ptions", "@jabber-add-buddy @jaddb*uddy @jabber-request-authorization @jreqa*uthorization", "@jabber-roster @jros*ter @jwho", "@jabber-remove-buddy @jrmb*uddy", "@jabber-message @jm @jp*age @jabber-reply @im @jmsg @jsay @jabber-emote @je*mote @jme @jr*eply", "@jabber-authorize @jabber-deny @jabber-approve", "@jabber-alias", "@jabber-gag @jabber-ungag @jgag @jungag", "@jabber-browse @jbrowse @jabber-info @jinfo", "@jabber-register @jabber-deregister @jderegister", "@jabber-login @jabber-logout @jlin @jlout"}
;_.("help_text") = {"A feature for communication with users on Jabber servers. It uses the Jabber s2s communication channel to transfer messages and presence information.", "", "There is also an API to receive Jabber messages via a verbs instead of a simple :tell()", "", "Receiving Jabber message events:", "  Add a verb to your player called `receive_jabber_message'. It will be called like so:", "   target:receive_jabber_message(<source JID>, <message string>)"}
;_.("aliases") = {"MOO-XMPP (Jabber) feature", "XMPP", "MOO-XMPP", "Jabber", "XMPP feature", "Jabber feature"}
;_.("description") = "This feature allows you to message Jabber users on other servers and manage Jabber buddy lists."

@verb _:"@jabber-o*ptions" any any any rxd
@program _:@jabber-options
"@jabber-option <option> [is] <value>   sets <option> to <value>";
"@jabber-option <option>=<value>        sets <option> to <value>";
"@jabber-option +<option>     sets <option>   (usually equiv. to <option>=1";
"@jabber-option -<option>     resets <option> (equiv. to <option>=0)";
"@jabber-option !<option>     resets <option> (equiv. to <option>=0)";
"@jabber-option <option>      displays value of <option>";
"";
"@jabber-options for a listing of available options.";
option_pkg = this.options;
if ((caller != player) || (caller_perms() != player))
  raise(E_PERM, "Unexpected caller");
endif
if (!args)
  player:tell_lines({"Current Jabber options:", "", @option_pkg:show(this:get_jabber_options(player), option_pkg.names)});
  return;
elseif (typeof(presult = option_pkg:parse(args)) == STR)
  player:tell(presult);
  return;
else
  if (length(presult) > 1)
    if (typeof(sresult = this:set_jabber_option(player, @presult)) == STR)
      player:tell(sresult);
      return;
    elseif (!sresult)
      player:tell("No change.");
      return;
    endif
  endif
  player:tell_lines(option_pkg:show(this:get_jabber_options(player), presult[1]));
endif
"Copied from generic player (#6):@misc-o by Xythian (#77) Thu May  2 20:56:02 1996 EDT";
"Copied from login watcher mark 2 (#83):@login-o by Kenny (#2) Mon Sep 26 22:59:31 2005 CDT";
.

@verb _:"options_propname" this none this
@program _:options_propname
{who} = args;
return tostr("_options_", who);
"Copied from login watcher mark 2 (#83):options_propname by Kenny (#2) Mon Sep 26 22:56:30 2005 CDT";
.

@verb _:"set_jabber_option" this none this
@program _:set_jabber_option
{who, @option} = args;
if (caller != this)
  raise(E_PERM);
endif
propname = this:options_propname(who);
result = this.options:set(this.(propname)[2], @option);
if (option[1] in {"hide", "avatar", "last"})
  fork (0)
    this:update_presence_for_user(who, 1);
  endfork
endif
if (typeof(result) == STR)
  return result;
elseif (equal(result, this.(propname)[2]))
  return 0;
else
  this.(propname)[2] = result;
  return 1;
endif
return;
"Copied from login watcher mark 2 (#83):set_login_option by Kenny (#2) Mon Sep 26 23:00:57 2005 CDT";
.

@verb _:"get_jabber_options jabber_option" this none this
@program _:get_jabber_options
{who, ?option = 0} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
propname = this:options_propname(who);
if (option)
  return this.options:get(`this.(propname)[2] ! E_PROPNF => {}', option);
else
  return this.(propname)[2];
endif
"Copied from login watcher mark 2 (#83):get_login_options by Kenny (#2) Mon Sep 26 23:01:08 2005 CDT";
.

@verb _:"feature_add" this none this
@program _:feature_add
{who} = args;
if (caller != who)
  raise(E_PERM);
endif
return this:add_user(who);
"Copied from login watcher mark 2 (#83):feature_add by Kenny (#2) Mon Sep 26 23:02:28 2005 CDT";
.

@verb _:"add_user" this none this
@program _:add_user
{who} = args;
if (caller != this)
  raise(E_PERM);
endif
this.users = {@this.users, who};
add_property(this, propname = this:options_propname(who), {{}, {}}, {this.owner, ""});
this.buddy_lists[who] = $dict.empty;
this.last_messaged[who] = #-1;
return 1;
.

@verb _:"remove_user" this none this
@program _:remove_user
{who} = args;
if (caller != this)
  raise(E_PERM);
endif
if (index = who in this.users)
  this.users = listdelete(this.users, index);
  `delete_property(this, this:options_propname(who)) ! E_PROPNF';
  this.buddy_lists = $dict:remove(this.buddy_lists, who);
  this.last_messaged = $dict:remove(this.last_messaged, who);
endif
return 1;
.

@verb _:"feature_remove" this none this
@program _:feature_remove
{who} = args;
if (caller != who)
  raise(E_PERM);
endif
return this:remove_user(who);
"Copied from login watcher mark 2 (#83):feature_remove by Kenny (#2) Mon Sep 26 23:03:34 2005 CDT";
.

@verb _:"_add_buddy" this none this
@program _:_add_buddy
{who, buddy} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (!$dict:is_dict(`buddy_list = this.buddy_lists[who] ! E_RANGE => 0'))
  buddy_list = $dict.empty;
endif
buddy.local_user = who;
if (!$dict:contains(buddy_list, buddy:short_jid()))
  buddy_list[buddy:short_jid()] = buddy;
  this.buddy_lists[who] = buddy_list;
  return buddy;
else
  return buddy_list[buddy:short_jid()];
endif
.

@verb _:"_list_buddies" this none this
@program _:_list_buddies
{who} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if ($dict:is_dict(`buddy_list = this.buddy_lists[who] ! E_RANGE => 0'))
  return $dict:keys(buddy_list);
else
  return {};
endif
.

@verb _:"@jabber-add-buddy @jaddb*uddy @jabber-request-authorization @jreqa*uthorization" any any any rxd
@program _:@jabber-add-buddy
"Usage: @jabber-add-buddy [Jabber ID]";
"       @jabber-request-authorization [Jabber ID]";
"";
"Adds a foreign Jabber ID to your roster and/or requests subscription from that user.";
if (player in this.users)
  if (!argstr)
    player:tell("Usage: ", verb, " [Jabber ID]");
    return;
  endif
  buddy = $local.jabber.buddy:new();
  if (`buddy:set_jid(argstr) ! ANY => 0')
    realbuddy = this:_add_buddy(player, buddy);
    realbuddy:subscribe();
    if (buddy == realbuddy)
      player:tell("Added \"", buddy:jid(), "\" to your roster.");
    else
      player:tell("Sent subscription request to \"", buddy:jid(), "\".");
    endif
  else
    if ((buddy = this:_get_buddy(player, argstr)) != $failed_match)
      buddy:subscribe();
      player:tell("Sent subscription request to ", buddy:alias(), ".");
    else
      player:tell("Invalid Jabber ID \"", argstr, "\" not added to roster.");
    endif
  endif
else
  player:tell("You must have ", this:namec(), " added as a feature before you add buddies.");
endif
.

@verb _:"@jabber-roster @jros*ter @jwho" any any any rxd
@program _:@jabber-roster
"Usage: @jabber-roster [all] [jid] [subscription] [authorization] [gag] [resources] [buddy...]";
"       @jwho [all] [jid] [subscription] [authorization] [gag] [resources] [buddy...]";
"";
"List out the buddies in your Jabber roster. Certain flags can be supplied as arguments to add information to the buddy list output. Here are the flags:";
"    all           - Lists out all your buddies regardless of whether they";
"                    are online or offline.";
"    jid           - Lists out the buddy's Jabber ID even if you have an";
"                    alias for them.";
"    subscription  - Lists out the subscription status of your buddy.";
"    sub           - Same as above.";
"                    Possible values:";
"                     none - Neither you nor your buddy have a subscription.";
"                     to - You have a subscription to this buddy.";
"                     from - This buddy has a subscription to you.";
"                     both - Both you and your buddy have subscription.";
"    authorization - Lists out the authorization you have for your buddy.";
"    auth          - Same as above.";
"                    Possible values:";
"                     no - This buddy can't add you to their roster.";
"                     yes - This buddy is authorized to add you.";
"                     denied - Authorization requests will be ignored.";
"    gag           - List out types of events you are gagging from this buddy.";
"    resources     - Lists out the individual resources your budy is using.";
"    res           - Same as above.";
if (player in this.users)
  (allflag = "all" in args) && (args = setremove(args, "all"));
  (jidflag = "jid" in args) && (args = setremove(args, "jid"));
  if (authflag = ("auth" in args) || ("authorization" in args))
    args = setremove(args, "auth");
    args = setremove(args, "authorization");
  endif
  if (subflag = ("sub" in args) || ("subscription" in args))
    args = setremove(args, "sub");
    args = setremove(args, "subscription");
  endif
  if (resourceflag = ("res" in args) || ("resources" in args))
    args = setremove(args, "res");
    args = setremove(args, "resources");
  endif
  (gagflag = "gag" in args) && (args = setremove(args, "gag"));
  buddies = {};
  if (rawbuddies = this:_list_buddies(player))
    headers = {"Name", "Status"};
    subflag && (headers = {@headers, "Sub"});
    authflag && (headers = {@headers, "Auth"});
    gagflag && (headers = {@headers, "Gag"});
    for buddyname in (rawbuddies)
      buddy = this.buddy_lists[player][buddyname];
      if (allflag || (!(buddy:status()[1] in {"offline", "invisible"})))
        name = buddy:alias();
        if (jidflag && (buddy:alias() != buddy:jid()))
          name = tostr(name, " [", buddy:jid(), "]");
        endif
        if ((!length(args)) || (name in args))
          if (resourceflag)
            resources = $dict:keys(buddy.resources);
          else
            resources = {""};
          endif
          for resource in (resources)
            buddies = {@buddies, {resource ? tostr(name, "/", resource) | name, this:_buddy_status(player, buddyname, resource)}};
            subflag && (buddies[$] = {@buddies[$], buddy.subscription});
            authflag && (buddies[$] = {@buddies[$], buddy.authorization});
            gagflag && (buddies[$] = {@buddies[$], $string_utils:from_list(buddy.gag) || "none"});
          endfor
        endif
      endif
    endfor
    player:tell_lines($string_utils:columnize_with_headers(headers, buddies));
    player:tell("Total ", length(buddies), " budd", (length(buddies) == 1) ? "y" | "ies", ".");
  else
    player:tell("You don't have any buddies in your Jabber roster yet!");
  endif
else
  player:tell("You must add ", this:namec(), " before you can have a roster.");
endif
.

@verb _:"_buddy_status" this none this
@program _:_buddy_status
{who, buddy, ?resource = ""} = args;
if (caller != this)
  raise(E_PERM);
endif
status = this.buddy_lists[who][buddy]:status(resource);
msg = status[1];
if (status[2])
  msg = tostr(msg, ": ", status[2]);
endif
return msg;
.

@verb _:"@jabber-remove-buddy @jrmb*uddy" any any any rxd
@program _:@jabber-remove-buddy
"Usage: @jabber-remove-buddy [Jabber ID]";
"";
"Removes a foreign Jabber ID from your roster and unsubscribes from their presence information.";
if (player in this.users)
  if (buddy = this:_remove_buddy(player, argstr))
    this:tell_user(player, "Buddy \"", buddy, "\" removed from your roster.");
  else
    this:tell_user(player, "That buddy does not exist in your roster!");
  endif
else
  player:tell("You must add ", this:namec(), " feature before you remove a buddy!");
endif
.

@verb _:"_remove_buddy" this none this
@program _:_remove_buddy
{who, buddy} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (!$dict:is_dict(`buddy_list = this.buddy_lists[who] ! E_RANGE => 0'))
  this.buddy_lists[who] = $dict.empty;
  return 0;
endif
if ((buddywaif = this:_get_buddy(who, buddy)) != $failed_match)
  this.buddy_lists[who] = $dict:remove(this.buddy_lists[who], buddywaif:short_jid());
  buddywaif:unsubscribe();
  return buddywaif:short_jid();
else
  return 0;
endif
.

@verb _:"receive_message" this none this
@program _:receive_message
{target, source, message, ?type = "chat"} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
jid = source;
if (valid(target = this:is_user(target)))
  if (validsource = this:_buddy_in_roster(target, source))
    {buddy, resource} = validsource;
    buddy = this:_get_buddy(target, buddy);
    source = buddy:alias();
    if (buddy:gagged("message"))
      return 0;
    endif
  elseif (this:jabber_option(target, "roster"))
    return;
  endif
  if (type == "error")
    target:tell("Your message to ", source, " couldn't be delivered.", message ? tostr(" (error: ", message, ")") | "");
  else
    "this.last_messaged[target] = jid;";
    if ($object_utils:has_verb(target, "receive_jabber_message"))
      if (`target:receive_jabber_message(source, message) ! ANY => 0')
        return 1;
      endif
    endif
    message = strsub(message, "~7E", "~");
    if (index(message, "~0A"))
      this:tell_user(target, "-- Page from ", source, " --");
      while (idx = index(message, "~0A"))
        this:tell_user(target, message[1..idx - 1]);
        message = `message[idx + 3..$] ! E_RANGE => ""';
      endwhile
      this:tell_user(target, "-- End of page from ", source, " --");
    else
      if ((length(message) > 4) && (message[1..4] == "/me "))
        this:tell_user(target, source, message[4..$]);
      else
        this:tell_user(target, source, " pages, \"", message, "\"");
      endif
    endif
  endif
  return 1;
else
  return 0;
endif
.

@verb _:"_buddy_in_roster" this none this
@program _:_buddy_in_roster
{who, buddy} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if ($dict:is_dict(`buddy_list = this.buddy_lists[who] ! ANY => 0'))
  if ($dict:contains(buddy_list, buddy))
    return {buddy, ""};
  elseif (index(buddy, "/") > 1)
    {buddy, resource} = $string_utils:explode(buddy, "/");
    if ($dict:contains(buddy_list, buddy))
      return {buddy, resource};
    endif
  endif
endif
return "";
.

@verb _:"is_user" this none this
@program _:is_user
{who} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (typeof(who) == STR)
  if (index(who, "@") > 1)
    who = who[1..index(who, "@") - 1];
  endif
  who = $string_utils:match_player(who);
  if (!valid(who))
    return $failed_match;
  endif
endif
if (who in this.users)
  return who;
else
  return $failed_match;
endif
.

@verb _:"_get_buddy" this none this
@program _:_get_buddy
{who, name} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
result = `this.buddy_lists[who][name] ! E_RANGE => $failed_match';
if (result == $failed_match)
  buddies = this.buddy_lists[who];
  for buddy in ($dict:keys(buddies))
    if (buddies[buddy]:alias() == name)
      return buddies[buddy];
    endif
  endfor
endif
return result;
.

@verb _:"receive_presence" this none this
@program _:receive_presence
{who, buddy, type, ?show = "", ?status = ""} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (valid(who = this:is_user(who)))
  if (validbuddy = this:_buddy_in_roster(who, buddy))
    {jid, resource} = validbuddy;
    buddy = this:_get_buddy(who, jid);
    if (((type == "online") || (type == "unavailable")) || (type == "invisible"))
      newtype = show ? show | type;
      if (newtype == "unavailable")
        newtype = "offline";
      endif
      {oldtype, oldstatus} = buddy:status(resource);
      if ((oldtype != newtype) || (oldstatus != status))
        if ((!this:jabber_option(who, "ignore")) && (!buddy:gagged("status")))
          this:tell_user(who, tostr(buddy:alias(), (buddy:status()[1] != newtype) ? tostr("/", resource) | "", " is now ", show ? show | newtype, status ? tostr(" (", status, ")") | "", "."));
        endif
        buddy:set_status(resource, newtype, status);
      endif
    elseif (type == "subscribe")
      buddy:set_authorization("requested");
    elseif (type == "unsubscribe")
      buddy:set_authorization("none");
    elseif (type == "unsubscribed")
      buddy:unsubscribe("silent");
      this:tell_user(who, tostr("Your subscription to presence information from ", buddy:alias(), " has been removed by the remote user."));
    elseif (type == "subscribed")
      buddy:subscribe("silent");
      this:tell_user(who, tostr("Your subscription to presence information from ", buddy:alias(), " has been approved."));
    elseif (type == "probe")
      buddy:send_local_user_presence();
    else
      this.owner:debug(args, "presence unknown");
    endif
  else
    "Unknown user requesting something";
    try
      newbuddy = $local.jabber.buddy:new();
      newbuddy:set_jid(buddy);
      newbuddy.local_user = who;
      if (type == "subscribe")
        this:_add_buddy(who, newbuddy);
        newbuddy:set_authorization("requested");
      elseif (type == "unsubscribe")
        newbuddy:set_authorization("none");
      endif
    except v (ANY)
      this.owner:debug({args, v}, "Jabber:receive_presence");
    endtry
  endif
endif
.

@verb _:"send_message" this none this
@program _:send_message
{from, to, msgtext} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
msg = $local.jabber:new_type_handler("message");
buddy = $local.jabber.buddy:new();
try
  buddy:set_jid(to);
except (ANY)
  to = this:_get_buddy(from, to);
  if (to == $failed_match)
    raise(E_INVIND, "recipient must either be an alias or a valid JID.");
  endif
  buddy = to;
endtry
msg.to = buddy:short_jid();
msg.from = tostr(this:user_jid(from), "/MOO");
msg.type = "chat";
msg.body = msgtext;
$local.jabber:send(msg);
return {from, buddy:alias(), msgtext};
.

@verb _:"user_jid" this none this
@program _:user_jid
{user} = args;
if (!(user in this.users))
  raise(E_PERM, "You must be a user of the ", this.name, " before using it!");
endif
if (jid = this:jabber_option(user, "jid"))
  return jid;
else
  return tostr(user:name(), "@", $local.jabber.site);
endif
.

@verb _:"@jabber-message @jm @jp*age @jabber-reply @im @jmsg @jsay @jabber-emote @je*mote @jme @jr*eply" any any any rxd
@program _:@jabber-message
"Usage: @jabber-message <Jabber ID> <message>";
"       @jm <Jabber ID> <message>";
"       @jabber-reply <message>";
"       @jr <message>";
"";
"Write a Jabber chat message to the given Jabber ID. Note that an alias previously set with @jabber-alias may also be used in place of the Jabber ID.";
"";
"When using the reply functionality, it will message the last person that you had written.";
if ((verb[1..3] == "@jr") || (verb == "@jabber-reply"))
  if (!argstr)
    player:tell("Usage: ", verb, " <message>");
    if ($dict:contains(this.last_messaged, player))
      player:tell("You last messaged `", this.last_messaged[player], "'.");
    endif
    return;
  endif
  target = `this.last_messaged[player] ! E_RANGE => $failed_match';
  message = argstr;
else
  if (length(args) < 2)
    return player:tell("Usage: ", verb, " <Jabber ID> [<message>]");
  endif
  delim = index(argstr, " ");
  target = argstr[1..delim - 1];
  message = argstr[delim + 1..$];
  "target = args[1];";
  "message = $string_utils:from_list(args[2..$], \" \");";
  this.last_messaged[player] = target;
endif
if (((verb[1..3] == "@je") || (verb == "@jabber-emote")) || (verb == "@jme"))
  message = tostr("/me ", message);
endif
try
  {from, target, message} = this:send_message(player, target, message);
except v (ANY)
  this.owner:debug(v);
  player:tell("Sorry, ", v[2]);
  return;
endtry
if (this:jabber_option(player, "echo"))
  prefix = this:jabber_option(player, "prefix") || this.options.default_prefix;
  if ((length(message) > 4) && (message[1..4] == "/me "))
    player:tell(prefix, " To ", target, ": ", this:user_jid(player), message[4..$]);
  else
    player:tell(prefix, " To ", target, ", \"", message, "\"");
  endif
else
  player:tell("Message sent to ", target, ".");
endif
.

@verb _:"tell_user" this none this
@program _:tell_user
{who, @msg} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
who:tell(this:jabber_option(who, "prefix") || this.options.default_prefix, " ", @msg);
.

@verb _:"@jabber-authorize @jabber-deny @jabber-approve" any any any rxd
@program _:@jabber-authorize
"Usage: @jabber-authorize <Jabber ID>";
"       @jabber-deny <Jabber ID>";
"";
"Allows a foreign Jabber user to subscribe to your presence information. Similarly it can also deny a foreign Jabber user from being authorized to view your presence information.";
if (length(args) != 1)
  player:notify(tostr("Usage: ", verb, " <Jabber ID>"));
  return;
endif
if (!(player in this.users))
  player:notify(tostr("You must be a user of ", this:namec(), " before you attempt to use it."));
  return;
endif
if ((buddy = this:_get_buddy(player, argstr)) != $failed_match)
  buddy:set_authorization((verb[9] == "d") ? "denied" | "yes");
  player:tell("You ", verb[9..$], " ", buddy:alias(), ".");
else
  player:tell("I can't find `", args[1], "' in your buddy list.");
endif
.

@verb _:"@jabber-alias" any any any rxd
@program _:@jabber-alias
"Usage: @jabber-alias <Jabber ID> <alias>";
"";
"Sets the alias for a Jabber ID in your roster to something easier to type and remember.";
if (length(args) != 2)
  player:tell("Usage: ", verb, " <Jabber ID> <alias>");
  return;
endif
if (!(player in this.users))
  player:tell("You must be a user of ", this:namec(), " before you attempt to use it.");
  return;
endif
if ($dict:contains(this.buddy_lists[player], args[1]))
  buddy = this.buddy_lists[player][args[1]];
  buddy.alias = args[2];
  player:tell("You have set the alias for `", buddy:jid(), "' to `", buddy:alias(), "'.");
else
  player:tell("I can't find `", args[1], "' in your buddy list.");
endif
.

@verb _:"update_presence_for_user" this none this
@program _:update_presence_for_user
{who, ?force_send = 0} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if ($waif:isa(buddy_list = `this.buddy_lists[who] ! E_RANGE => 0', $waif))
  for buddy in ($dict:keys(buddy_list))
    buddy_list[buddy]:send_local_user_presence(force_send);
  endfor
endif
.

@verb _:"player_disconnected player_connected" this none this
@program _:player_disconnected
{who, @rest} = args;
this:update_presence_for_user(who);
.

@verb _:"probe_all_buddies" this none this
@program _:probe_all_buddies
{who} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (valid(who = this:is_user(who)))
  buddy_list = this.buddy_lists[who];
  for buddy in ($dict:keys(buddy_list))
    buddy_list[buddy]:probe_presence();
  endfor
endif
.

@verb _:"@jabber-gag @jabber-ungag @jgag @jungag" any any any rxd
@program _:@jabber-gag
"Usage: @jabber-gag <Jabber ID>[=<type>,<type>,...]";
"       @jabber-ungag <Jabber ID>[=<type>,<type>...]";
"";
"   Ex: @jabber-gag loser@example.com=message,roster";
"       @jabber-ungag loser@example.com";
"";
"Prevent a certain Jabber buddy from sending you an instant message. Note that gagging a buddy not on your roster will add them for the purposes of tracking their gag status. You may combine different gag types by listing them out with comma separators. Omitting the types is synonymous with specifying \"all\".";
"";
"The types of gags available are:";
"  all     - Gag all types of events from the buddy.";
"  message - Gag messages from the buddy.";
"  status  - Gag status events from the buddy.";
if (player in this.users)
  if ((verb[3] == "u") || (verb == "@jabber-ungag"))
    action = "ungag";
  else
    action = "gag";
  endif
  if (!`{jid, typestr} = $string_utils:explode(argstr, "=") ! ANY => 0')
    jid = argstr;
    typestr = "all";
  endif
  types = $string_utils:explode(typestr, ",");
  if (!types)
    return player:tell("Usage: ", verb, " <Jabber ID>[=<type>,<type>,...]");
  endif
  if (buddy = this:_get_buddy(player, jid))
    buddy = this.buddy_lists[player][buddy];
  else
    buddy = $local.jabber.buddy:new();
    try
      buddy:set_jid(argstr);
      this:_add_buddy(player, buddy);
    except v (ANY)
      return this:tell_user(player, tostr("Sorry, ", v[2], "."));
    endtry
  endif
  try
    buddy:(action)(types);
    this:tell_user(player, tostr("You are now gagging ", $string_utils:english_list(buddy.gag, "no"), " events from ", buddy:alias(), "."));
  except v (ANY)
    this:tell_user(player, tostr("Sorry, ", v[2], "."));
  endtry
else
  player:tell("You must add ", this:namec(), " as a feature before you use this command.");
endif
.

@verb _:"find_iq_request" this none this
@program _:find_iq_request
return 1;
.

@verb _:"@jabber-browse @jbrowse @jabber-info @jinfo" any any any rxd
@program _:@jabber-browse
"Usage: @jabber-browse <JabberID>";
"";
"Browses a Jabber ID to see what services it offers.";
if (!(player in this.users))
  return player:tell("You must be a user of ", this:namec(), " first!");
endif
if ((verb[3] == "b") || (verb == "@jabber-browse"))
  type = "items";
else
  type = "info";
endif
try
  iq = $local.jabber:new_type_handler("iq");
  iq.to = argstr;
  iq.from = this:user_jid(player);
  iq.type = "get";
  query = iq:add_entity("query");
  query:add_attribute("xmlns", tostr("http://jabber.org/protocol/disco#", type));
  $local.jabber:send(iq);
  this:tell_user(player, "Querying `", iq.to, "'...");
except v (ANY)
  player:tell("Sorry, ", v[2], ".");
endtry
.

@verb _:"receive_iq_reply" this none this
@program _:receive_iq_reply
{who, iq, children} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
this.owner:debug(children);
if (children)
  for child in (children)
    lines = {};
    if (child[1] == "query")
      if (index(child[2][1][2], "http://jabber.org/protocol/disco#items"))
        items = {{iq.from, {}}};
        if (child[4])
          for item in (child[4])
            jid = "unknown???";
            name = "";
            for attribute in (item[2])
              if (attribute[1] == "jid")
                jid = attribute[2];
              elseif (attribute[1] == "name")
                name = attribute[2];
              endif
            endfor
            if (name)
              name = tostr(name, " (", jid, ")");
            else
              name = jid;
            endif
            items[1][2] = {@items[1][2], {name, {}}};
          endfor
          lines = {tostr("Reply from `", iq.from, "'."), @this:tree_print(items)};
        else
          lines = {tostr("Empty reply from `", iq.from, "'.")};
        endif
        lines = {@lines, tostr("Total: ", length(child[4]), " item", (length(child[4]) == 1) ? "" | "s", ".")};
      elseif (index(child[2][1][2], "http://jabber.org/protocol/disco#info"))
        lines = {tostr("Reply from `", iq.from, "'.")};
        for info in (child[4])
          if (info[1] == "identity")
            category = type = name = "";
            for attrib in (info[2])
              if (attrib[1] == "category")
                category = attrib[2];
              elseif (attrib[1] == "type")
                type = attrib[2];
              elseif (attrib[1] == "name")
                name = attrib[2];
              endif
            endfor
            lines = {@lines, tostr(category, type ? tostr(" (", type, ")") | "", " named ", name)};
          elseif (info[1] == "feature")
            if (info[2][1][1] == "var")
              lines = {@lines, tostr(" feature ", info[2][1][2])};
            endif
          endif
        endfor
        lines = {@lines, tostr("Total: ", length(child[4]), " item", (length(child[4]) == 1) ? "" | "s", ".")};
      elseif (index(child[2][1][2], "jabber:iq:register"))
        need_xdata = 0;
        fields = instructions = "";
        for field in (child[4])
          if (field[1] == "instructions")
            instructions = field[3];
          else
            if (field[1] == "x")
              need_xdata = 1;
            else
              fields = tostr(fields, " ", field[1], "=", field[3] ? field[3] | tostr("<", field[1], ">"), " ");
            endif
          endif
          lines = {instructions};
          if (need_xdata)
            lines = {@lines, "Sorry, this is not currently possible on the MOO!"};
          else
            lines = {@lines, tostr("@jabber-register ", iq.from, fields)};
          endif
        endfor
      endif
    endif
    if (lines)
      for line in (lines)
        this:tell_user(who, line);
      endfor
    else
      this:tell_user(who, "Unknown reply from `", iq.from, "'.");
    endif
  endfor
else
  this:tell_user(who, "Empty reply received from `", iq.from, "'.");
endif
.

@verb _:"tree_print" this none this
@program _:tree_print
{items, ?prefix = "", ?subprefix = ""} = args;
printed = 0;
preflen = length(prefix);
if (items)
  lines = this:tree_print(items[1][2], tostr(prefix, prefix ? tostr("-", (length(items) == 1) ? "-" | "+", "-") | "", items[1][1]), tostr(subprefix, prefix ? " | " | "", $string_utils:space(length(items[1][1]), " ")));
  for idx in [2..length(items)]
    if (preflen)
      lines = {@lines, @this:tree_print(items[idx][2], tostr(subprefix, prefix ? " +-" | "", items[idx][1]), tostr(subprefix, " | ", $string_utils:space(length(items[idx][1]))))};
    endif
  endfor
  return lines;
else
  return {prefix};
endif
.

@verb _:"receive_iq_error" this none this
@program _:receive_iq_error
{who, iq, children} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
error_reason = "";
for error in (children)
  if (error[1] == "error")
    error_reason = error[4][1][1];
  endif
endfor
this:tell_user(who, "Error reply from `", iq.from, "'", error_reason ? tostr(": ", error_reason, ".") | ".");
.

@verb _:"@jabber-register @jabber-deregister @jderegister" any any any rxd
@program _:@jabber-register
"Usage: @jabber-register <JabberID> [<field1>=<field1 data> ...]";
"       @jabber-register aim.example.org username=AIMUser password=Secret!";
"";
"Registers with any Jabber node that supports registration.";
if (!(player in this.users))
  return player:tell("You must be a user of ", this:namec(), " first!");
endif
if (!args)
  return player:tell("Usage: ", verb, " <Jabber ID> [<field1>=<field1 data> ...]");
endif
if ((verb[3] == "d") || (verb == "@jabber-deregister"))
  type = "deregister";
else
  type = "register";
endif
try
  iq = $local.jabber:new_type_handler("iq");
  iq.to = args[1];
  args = listdelete(args, 1);
  iq.from = this:user_jid(player);
  query = iq:add_entity("query");
  query:add_attribute("xmlns", "jabber:iq:register");
  if (type == "deregister")
    iq.type = "set";
    query:add_entity("remove");
    this:tell_user(player, "Asking `", iq.to, "' to deregister...");
  else
    if (args)
      iq.type = "set";
      for arg in (args)
        idx = index(arg, "=");
        if (length(arg) <= idx)
          return player:tell("You cannot have blank arguments.");
        endif
        key = arg[1..idx - 1];
        value = arg[idx + 1..$];
        newent = query:add_entity(key);
        newent.data = value;
      endfor
    else
      iq.type = "get";
    endif
    this:tell_user(player, "Asking `", iq.to, "' about registration...");
  endif
  $local.jabber:send(iq);
except v (ANY)
  player:tell("Sorry, ", v[2], ".");
endtry
.

@verb _:"@jabber-login @jabber-logout @jlin @jlout" any any any rxd
@program _:@jabber-login
"Usage: @jabber-login <Jabber ID>";
"       @jabber-logout <Jabber ID>";
"";
"   Ex: @jabber-login yahoo.example.com";
"";
"Logs in or out of a Jabber agent or transport.";
if (!(player in this.users))
  return player:tell("You must be a user of ", this:namec(), " first!");
endif
if (!args)
  return player:tell("Usage: ", verb, " <Jabber ID>");
endif
if (index(verb, "out"))
  type = "unavailable";
else
  type = "";
endif
try
  presence = $local.jabber:new_type_handler("presence");
  to = this:_get_buddy(player, args[1]);
  if (to == $failed_match)
    return this:tell_user(player, "That user does not exist in your Jabber roster!");
  endif
  presence.to = to:jid();
  presence.from = this:user_jid(player);
  if (type)
    presence.type = type;
    this:tell_user(player, "Logging out of `", presence.to, "'...");
  else
    this:tell_user(player, "Logging into `", presence.to, "'...");
  endif
  $local.jabber:send(presence);
except v (ANY)
  this.owner:debug(v);
  player:tell("Sorry, ", v[2], ".");
endtry
.

"***finished***
