@building-option +create-set-co
@create $generic_options named MOO-XMPP options:MOO-XMPP options,Jabber options,XMPP options
@prop _."show_hide" {} rc
;_.("show_hide") = {"Broadcast my presence to the buddies in my roster.", "Don't broadcast my status to the buddies in my roster."}
@prop _."show_ignore" {} rc
;_.("show_ignore") = {"Do receive status changes for buddies in my roster.", "Don't receive status changes for buddies in my roster."}
@prop _."show_roster" {} rc
;_.("show_roster") = {"Listen to any incoming event.", "Listen only to events from people in my buddy list."}
@prop _."show_doing" {} rc
;_.("show_doing") = {"Don't send your local `doing' message in presence updates.", "Do send your local `doing' message in presence updates."}
@prop _."show_echo" {} rc
;_.("show_echo") = {"Don't echo back outgoing messages.", "Do echo back outgoing messages."}
@prop _."default_prefix" "*** Jabber:" rc
@prop _."show_last" {} rc
;_.("show_last") = {"Don't show idle seconds to others.", "Do show idle seconds to people on roster."}
;_.("names") = {"jid", "roster", "doing", "hide", "ignore", "echo", "prefix", "avatar", "last"}
;_.("_namelist") = "!jid!roster!doing!hide!ignore!echo!prefix!avatar!last!"
;_.("category") = "xmpp"
;_.("command") = "@xmpp-options"
;_.("used_for") = "the MOO-XMPP feature"
;_.("aliases") = {"MOO-XMPP options", "Jabber options", "XMPP options"}
;_.("description") = "An option package used for the Jabber feature."

@verb _:"show_jid" this none this
@program _:show_jid
value = this:get(@args);
if (!value)
  value = tostr(player:name(), "@", $local.jabber.site);
endif
return {"", {tostr("Preferred Jabber ID: ", value)}};
.

@verb _:"check_jid" this none this
@program _:check_jid
{value} = args;
return {value};
.

@verb _:"parse_jid" this none this
@program _:parse_jid
input = args[2];
if (typeof(input) == LIST)
  input = $string_utils:from_list(input, " ");
endif
jid = $local.jabber.buddy:new();
try
  jid:set_jid(input);
except v (E_INVIND)
  return v[2];
endtry
host = $local.jabber:find_jabber_hostname(jid.host);
if (host != $local.jabber.site)
  return tostr("That is an invalid Jabber ID. The host `", jid.host, "' does not have a SRV record that points to `", $local.jabber.site, "'.");
endif
target = $local.jabber.feature:is_user(jid.user);
if ((typeof(target) == OBJ) && (target != player))
  return "That is an invalid Jabber ID. You must use one of your own aliases for the user part!";
endif
args[2] = jid:short_jid();
return args[1..2];
.

@verb _:"show_prefix" this none this
@program _:show_prefix
value = this:get(@args);
if (!value)
  value = this.default_prefix;
endif
return {"", {tostr("Jabber message prefix: ", value)}};
.

@verb _:"check_prefix" this none this
@program _:check_prefix
{value} = args;
return {value};
.

@verb _:"parse_prefix" this none this
@program _:parse_prefix
input = args[2];
if (typeof(input) == LIST)
  input = $string_utils:from_list(input, " ");
elseif (typeof(input) != STR)
  input = this.default_prefix;
endif
args[2] = input;
return args[1..2];
.

@verb _:"check_avatar" this none this
@program _:check_avatar
{value} = args;
return {value};
.

@verb _:"parse_avatar" this none this
@program _:parse_avatar
{name, input, @junk} = args;
if (typeof(input) == LIST)
  input = $string_utils:from_list(input, " ");
elseif (typeof(input) != STR)
  input = "";
endif
type = "";
b64 = "";
hash = "";
if (input)
  if (response = `$http:get_now_b(input, 1) ! E_INVARG => 0')
    data = decode_binary(response[2], 1);
    if (size = `$local.image_utils:image_size(data) ! ANY => 0')
      if (!((((size[1] >= 32) && (size[1] <= 96)) && (size[2] >= 32)) && (size[2] <= 96)))
        return "Avatar image must be between 32x32 and 96x96 pixels.";
      endif
      b64 = $local.image_utils:base64_encode(response[2]);
      hash = tostr(string_hash(response[2]), "00000000");
      type = size[3];
    else
      return "Unsupported image format.";
    endif
  else
    return "Cannot retrieve specified URL.";
  endif
endif
return {name, {input, hash, type, b64}};
"return {name, {input, $local.crypto:sha1(data), type, b64}};";
.

@verb _:"show_avatar" this none this
@program _:show_avatar
value = this:get(@args);
if (!value)
  return {"", {"Avatar image URL."}};
else
  return {"", {tostr("Avatar image URL: ", value[1])}};
endif
.

"***finished***
