@building-option +create-set-co
@create #1900 named XMPP buddy:XMPP buddy,Jabber buddy,jbuddy,xmppbuddy
@prop _.":host" "" ""
@prop _.":user" "" ""
@prop _.":resources" {} ""
@prop _."valid_show_types" {} rc
;_.("valid_show_types") = {"online", "away", "chat", "dnd", "xa", "invisible", "offline"}
@prop _.":subscription" "none" ""
@prop _."valid_subscription_types" {} rc
;_.("valid_subscription_types") = {"to", "from", "both"}
@prop _.":alias" "" ""
@prop _.":authorization" "none" ""
@prop _.":local_user" #-1 ""
@prop _.":gag" {} rc
@prop _."gag_types" {} rc
;_.("gag_types") = {"message", "status", "all"}
;_.("key") = 0
;_.("aliases") = {"XMPP buddy", "Jabber buddy", "jbuddy", "xmppbuddy"}
;_.("offered") = #-1
;_.("object_size") = {12174, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":jid" this none this
@program _::jid
{?resource = ""} = args;
if (this.host)
  jid = this.host;
  if (this.user)
    jid = tostr(this.user, "@", jid);
  endif
  if (resource && (resource in this.resources))
    jid = tostr(jid, "/", resource);
  endif
  return jid;
endif
return "";
.

@verb _:":set_jid" this none this
@program _::set_jid
{jid} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
{user, host, resource} = $local.jabber:split_jid(jid);
this.user = user;
this.host = host;
return 1;
.

@verb _:":short_jid" this none this
@program _::short_jid
jid = "";
if (this.host)
  jid = this.host;
  if (this.user)
    jid = tostr(this.user, "@", jid);
  endif
endif
return jid;
.

@verb _:":set_status" this none this
@program _::set_status
{resource, show, ?status = ""} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (show in this.class.valid_show_types)
  if (show == "offline")
    this.resources = $dict:remove(this.resources, resource);
    return;
  else
    return this.resources[resource] = {show, status};
  endif
else
  raise(E_INVIND, tostr("invalid presence status (", show, ", ", status, ")"));
endif
.

@verb _:":subscribe :unsubscribe" this none this
@program _::subscribe
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
{?silent = 0} = args;
if (verb == "unsubscribe")
  type = "unsubscribe";
  if (this.subscription == "both")
    this.subscription = "from";
  elseif (this.subscription == "to")
    this.subscription = "none";
  endif
else
  type = "subscribe";
  if (this.subscription == "none")
    this.subscription = "to";
  elseif (this.subscription == "from")
    this.subscription = "both";
  endif
endif
if (!silent)
  presence = $local.jabber:new_type_handler("presence");
  presence.type = type;
  presence.from = $local.jabber.feature:user_jid(this.local_user);
  presence.to = this:short_jid();
  $local.jabber:send(presence);
  this:send_local_user_presence(1);
endif
.

@verb _:":subscribed :unsubscribed" this none this
@program _::subscribed
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (verb[2] == "u")
  if (this.subscription == "both")
    this.subscription = "to";
    return 1;
  elseif (this.subscription == "from")
    this.subscription = "none";
    return 1;
  else
    return 0;
  endif
else
  if (this.subscription == "none")
    this.subscription = "from";
    return 1;
  elseif (this.subscription == "to")
    this.subscription = "both";
    return 1;
  else
    return 0;
  endif
endif
.

@verb _:":alias" this none this
@program _::alias
return this.alias ? this.alias | this:short_jid();
.

@verb _:":set_alias" this none this
@program _::set_alias
{alias} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
return this.alias = alias;
.

@verb _:":set_authorization" this none this
@program _::set_authorization
{status} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (status == "requested")
  if (this.authorization == "denied")
    return;
  elseif (this.authorization == "none")
    this.authorization = "requested";
    $local.jabber.feature:tell_user(this.local_user, tostr(this:alias(), " is requesting authorization to have you on their Jabber roster. Use `@jabber-authorize ", this:alias(), "' to allow them or `@jabber-deny ", this:alias(), "' to ignore them."));
  endif
elseif (status == "denied")
  this.authorization = status;
elseif (status == "yes")
  presence = $local.jabber:new_type_handler("presence");
  presence.type = "subscribed";
  presence.to = this:short_jid();
  presence.from = $local.jabber.feature:user_jid(this.local_user);
  $local.jabber:send(presence);
  this.authorization = "yes";
  if (this.subscription == "none")
    this.subscription = "from";
  elseif (this.subscription == "to")
    this.subscription = "both";
  endif
  this:send_local_user_presence(1);
elseif (status == "none")
  presence = $local.jabber:new_type_handler("presence");
  presence.type = "unsubscribed";
  presence.to = this:short_jid();
  presence.from = $local.jabber.feature:user_jid(this.local_user);
  $local.jabber:send(presence);
  this.authorization = "none";
  if (this.subscription == "both")
    this.subscription = "to";
  elseif (this.subscription == "from")
    this.subscription = "none";
  endif
endif
.

@verb _:":send_local_user_presence" this none this
@program _::send_local_user_presence
{?force_send = 0} = args;
if ((!(caller in {this, $local.jabber.feature})) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
status = "unavailable";
doing = "";
send = force_send ? 1 | 0;
if ((!$local.jabber.feature:jabber_option(this.local_user, "hide")) && ((this.subscription == "from") || (this.subscription == "both")))
  if (this.local_user in $code_utils:connected_players())
    status = "";
    if ($local.jabber.feature:jabber_option(this.local_user, "doing"))
      doing = this.local_user:doing_msg();
    endif
  endif
  send = 1;
endif
if (send)
  presence = $local.jabber:new_type_handler("presence");
  presence.to = this:short_jid();
  presence.from = $local.jabber.feature:user_jid(this.local_user);
  if (status)
    presence.type = status;
  else
    presence.status = doing;
  endif
  x = $local.jabber.moldable:new();
  x.stanza = "x";
  presence:add_child(x);
  x:add_attribute("xmlns", "vcard-temp:x:update");
  photo = $local.jabber.moldable:new();
  photo.stanza = "photo";
  x:add_child(photo);
  x2 = $local.jabber.moldable:new();
  x2.stanza = "x";
  presence:add_child(x2);
  x2:add_attribute("xmlns", "jabber:x:avatar");
  feature = $local.jabber.feature;
  photo_data = feature.options:get(feature:get_jabber_options(this.local_user), "avatar");
  if (photo_data)
    photo.data = photo_data[2];
    hash = $local.jabber.moldable:new();
    hash.stanza = "hash";
    hash.data = photo_data[2];
    x2:add_child(hash);
  endif
  $local.jabber:send(presence);
endif
.

@verb _:":probe_presence" this none this
@program _::probe_presence
{?force_send = 0} = args;
if ((!(caller in {this, $local.jabber.feature})) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
presence = $local.jabber:new_type_handler("presence");
presence.to = this:short_jid();
presence.from = $local.jabber.feature:user_jid(this.local_user);
presence.type = "probe";
$local.jabber:send(presence);
.

@verb _:":gag :ungag" this none this
@program _::gag
{input} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (typeof(input) == STR)
  input = {input};
endif
if (verb[1] == "u")
  if ("all" in input)
    this.gag = {};
  else
    for type in (input)
      this.gag = setremove(this.gag, type);
    endfor
  endif
elseif (!("all" in this.gag))
  if ("all" in input)
    this.gag = {"all"};
  else
    for type in (input)
      if (type in this.class.gag_types)
        this.gag = setadd(this.gag, type);
      else
        raise(E_INVARG, tostr("gag type `", type, "' is invalid"));
      endif
    endfor
  endif
endif
.

@verb _:":gagged" this none this
@program _::gagged
{type} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
return (type in this.gag) || ("all" in this.gag);
.

@verb _:":status" this none this
@program _::status
{?resource = ""} = args;
status = {"offline", ""};
if (!$dict:is_dict(this.resources))
  this.resources = $dict:new();
endif
if (resource)
  if ($dict:contains(this.resources, resource))
    status = this.resources[resource];
  endif
else
  rank = $maxint;
  for resource in ($dict:keys(this.resources))
    testrank = this.resources[resource][1] in this.class.valid_show_types;
    if (testrank < rank)
      rank = testrank;
      status = this.resources[resource];
    endif
  endfor
endif
return status;
.

"***finished***
