@building-option +create-set-co
@create #1900 named XMPP IQ:XMPP IQ,Jabber IQ,jiq,xmppiq
@prop _.":id" "" ""
@prop _."child" #5544 rc
@prop _.":type" "" ""
@prop _."stanza" "iq" rc
@prop _."registry" {waif} rc
@prop _."error_codes" {waif} rc
;_.("key") = 0
;_.("aliases") = {"XMPP IQ", "Jabber IQ", "jiq", "xmppiq"}
;_.("offered") = #-1
;_.("object_size") = {9761, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{connection, type, attributes, text, children} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
this:set_many(attributes);
handled = 0;
if (this.type == "get")
  handled = this:handle_get(children);
elseif (this.type == "result")
  handled = this:handle_result(children);
elseif (this.type == "error")
  handled = this:handle_error(children);
else
  handled = this:handle_query(children);
endif
if (!handled)
  this.owner:debug({this.type, children}, "Unknown IQ");
  this:error(children);
endif
.

@verb _:":serialize" this none this
@program _::serialize
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
xml = {this.class.stanza, {{"type", this.type}, {"from", this.from}, {"to", this.to}, {"id", this.id}}, "", {}};
for child in (this.children)
  xml[4] = {@xml[4], child:serialize(0)};
endfor
return $local.xml:xml_unparse(@xml);
.

@verb _:":add_entity" this none this
@program _::add_entity
{stanza} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
child = this.class.child:new();
child.stanza = stanza;
this.children = {@this.children, child};
return child;
.

@verb _:":error" this none this
@program _::error
{children, ?code = 501, ?origin = this} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
erriq = $local.jabber:new_type_handler("iq");
erriq.to = origin.from;
erriq.from = origin.to;
erriq.id = origin.id;
erriq.type = "error";
erriqc1 = erriq:add_entity("query");
erriqc1.stanza = children[1][1];
erriqc1:set_many(children[1][2]);
erriqc2 = erriq:add_entity("error");
{entity, type} = this.class.error_codes[code];
erriqc2:add_attribute("code", tostr(code));
erriqc2:add_attribute("type", type);
erriqc2msg = erriqc2:add_entity(entity);
erriqc2msg:add_attribute("xmlns", "urn:ietf:xml:params:ns:xmpp-stanzas");
$local.jabber:send(erriq);
.

@verb _:":handle_result" this none this
@program _::handle_result
{children} = args;
if (caller != this)
  raise(E_PERM);
endif
if (valid(who = $local.jabber.feature:is_user(this.to)))
  if (!(request = $local.jabber.feature:find_iq_request(this.id)))
    return 0;
  endif
  $local.jabber.feature:receive_iq_reply(who, this, children);
else
  this.owner:debug({this.to, who}, "Unknown IQ result dest");
  return 0;
endif
return 1;
.

@verb _:":initialize" this none this
@program _::initialize
if ((caller == this) || (caller == this.class))
  this:generate_id();
else
  raise(E_PERM);
endif
.

@verb _:":generate_id" this none this
@program _::generate_id
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
randomized = tostr(time(), random());
new_id = string_hash(randomized);
return this.id = new_id;
.

@verb _:":handle_error" this none this
@program _::handle_error
{children} = args;
if (caller != this)
  raise(E_PERM);
endif
if (valid(who = $local.jabber.feature:is_user(this.to)))
  request = $local.jabber.feature:find_iq_request(this.id);
  $local.jabber.feature:receive_iq_error(who, this, children);
else
  this.owner:debug({this.to, who}, "Unknown IQ result dest");
  return 0;
endif
return 1;
.

@verb _:":handle_get" this none this
@program _::handle_get
{children} = args;
if (caller != this)
  raise(E_PERM);
endif
if (valid(who = $local.jabber.feature:is_user(this.to)) || (this.to == $local.jabber.site))
  "if (children[1][1] == \"query\")";
  handler_type = `$local.jabber.iq.registry[children[1][2][1][2]] ! E_RANGE => $nothing';
  if (!valid(handler_type))
    return 0;
  endif
  handler = handler_type:new();
  return handler:handle(children, this);
  " endif";
  " return 0;";
else
  this.owner:debug({this.to, who}, "Unknown IQ result dest");
  return 0;
endif
.

@verb _:":handle_query" this none this
@program _::handle_query
{children} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (children[1][2][1][2] != "http://jabber.org/protocol/disco#info")
  return 0;
endif
infoiq = $local.jabber:new_type_handler("iq");
infoiq.to = this.from;
infoiq.from = this.to;
infoiq.id = this.id;
infoiq.type = "error";
infoiqc1 = infoiq:add_entity("query");
for feature in (setremove($dict:keys($local.jabber.iq.registry), children[1][2][1][2]))
  featureiq = infoiqc1:add_entity("feature");
  featureiq:add_attribute("var", feature);
endfor
$local.jabber:send(infoiq);
return 1;
.

"***finished***
